# -*- coding:utf-8 -*-
#
__script__ = "PyDocViewer"
__ver__    = "0.03(0)"
__author__ = 'masa'
__web__    = "http://masaland.cocolog-nifty.com/"
__Copyright__ = '(C) 2014-2017 masa'

#
# 画面右端で折り返さず表示できるアプリ
#

import sys
import os
if os.path.isdir('E:\\Python\\lib') :
    sys.path.insert(0, 'E:\\Python\\lib')
#sys.path.insert(0, 'e:\\resource')
sys.setdefaultencoding('utf-8')

try:
    import japanese
except:
    appuifw.query(unicode("Japanese codecs をインストールして下さい", "utf-8"), "query")

import appuifw
import e32
from graphics import *
#from key_codes import *
from key_codes import EKeyLeftArrow
from key_codes import EKeyRightArrow
from key_codes import EKeyUpArrow
from key_codes import EKeyDownArrow
from key_codes import EKeySelect
from key_codes import EKeyEnter
from key_codes import EKey2, EKey8, EKey4, EKey6, EKey1, EKey3
from key_codes import EKeyStar
from key_codes import EKeyHash #*01E7
import re

try:
    from PyFbuiutil import Fbrowser
    from PyFbuiutil import Getpath
except:
    appuifw.query(unicode("PyFbuiutil をインストールして下さい", "utf-8"), "query")

class viewer:
    
    def __init__(self):
        self.status=1
        self.viewing=1
        self.lastNo=0
        self.staSLNo=0
        self.botSLNo=0
        self.scrData = []
        self.curLNo = 0
        self.dspSTpos = 0  #colum position to disp. start
        self.word_wrap = 0 #*
        self.last_find = "" #* search word
        self.line_number = 1 #*0:non 1:word pro. like 2:editor like
        self.edit_fontsize = 24
        self.script_lock = e32.Ao_lock()
        self.menu_exit = (unicode("Exit"), self.do_exit)
        self.menu_file = (unicode("File"), self.open_file)
        self.menu_find = (unicode("Find"),
                     ((unicode("Find"), self.findtext),
                      (unicode("Find next"), lambda: self.findtext(self.last_find)),
                      (unicode("Find all"), self.find_all),
                      (unicode("Find all again"), lambda: self.find_all(self.last_find))))
        self.menu_find_ed = (unicode("Find"),
                     ((unicode("Find"), self.find_ed),
                      (unicode("Find next"), lambda: self.find_ed(self.last_find)),
                      (unicode("Find all"), self.find_all_ed),
                      (unicode("Find all again"), lambda: self.find_all_ed(self.last_find))))
        self.menu_jump = (unicode("Go to"), self.jumpnum)
        self.menu_info = (unicode("About"), self.about)
        self.menu_option = (unicode("Option"),
                       ((unicode("word wrap %s" %("On","Off")[self.word_wrap]), self.wrap_onoff),
                        (unicode("Line number"), self.line_num_state)))
        self.menu_edit = (unicode("Edit"),
                         ((unicode("Edit line"), self.edit_line),
                          (unicode("Insert line"), self.insert_line),
                          (unicode("Delete line"), self.delete_line)))
        self.menu_edit_ed = (unicode("Edit"),
                         ((unicode("Done"),self.edit_done),
                          (unicode("Cancel"),self.edit_can)))
        self.menu_save = (unicode("File"),
                         ((unicode("Save"), self.save),
                          (unicode("Save as (new file)"), self.save_as)))
        self.menu_goto_ed = (unicode("Go to"),
                         ((unicode("Top"), self.go_top),
                          (unicode("End"), self.go_end)))

        self.Gpath = Getpath()
        self.file_path = ''
        self.Encoding='Shift-JIS'
        self.Edit_flag=0
        self.viewing=1


        #for Customize
        self.MOJI1=44
        self.GYOU1=37
        self.HABA1=17
        self.k_left1=EKey4
        self.k_right1=EKey6
        self.k_up1=EKeyUpArrow
        self.k_down1=EKeyDownArrow
        self.k_state1=EKeySelect
        self.k_enter1=EKeyEnter     #*01
        self.k_oup1=EKey2
        self.k_odown1=EKey8
        self.k_lntop1=EKey1
        self.k_sleft1=EKeyLeftArrow
        self.k_sright1=EKeyRightArrow
        self.k_rot1=EKeyStar
        self.k_softkeybar1=EKeyHash #*01E7
        self.MOJI2=79
        self.GYOU2=21
        self.HABA2=17
        self.k_left2=EKey2
        self.k_right2=EKey8
        self.k_up2=EKeyUpArrow
        self.k_down2=EKeyDownArrow
        self.k_state2=EKeySelect
        self.k_enter2=EKeyEnter     #*01
        self.k_oup2=EKey6
        self.k_odown2=EKey4
        self.k_lntop2=EKey3
        self.k_sleft2=EKeyLeftArrow
        self.k_sright2=EKeyRightArrow
        self.k_rot2=EKeyStar
        self.k_softkeybar2=EKeyHash  #*01E7
        self.pathtmp = "E:\\Documents\\"
#        self.FONT=(u"MS Gothic", 16, FONT_BOLD|FONT_ANTIALIAS) #*01
        self.FONT=(u"WenQuanYi Zen Hei", 24, FONT_BOLD|FONT_ANTIALIAS) #*01E7
        self.MOJI=44
        self.GYOU=37
        self.HABA=17


    def rot_land(self):
        if self.Edit_flag and self.word_wrap:
            rtn = appuifw.query(unicode("When exec rotate\nedit is discarded\ndata already saved ?"), "query")
            if not rtn:
                return
        appuifw.app.orientation='landscape'
#        appuifw.app.screen = "full"
        self.MOJI=self.MOJI2
        self.GYOU=self.GYOU2
        self.HABA=self.HABA2
        
        self.canvas.bind(self.k_lntop1, self.do_dummy) #* change to unuse, -
        #* - use do_dummy, never use 'None'(if use, error occured in first time)
        self.canvas.bind(self.k_left2, self.moveleft)
        self.canvas.bind(self.k_right2, self.moveright)
        self.canvas.bind(self.k_up2, self.lineup)
        self.canvas.bind(self.k_down2, self.linedown)
        self.canvas.bind(self.k_state2, self.statechange)
        self.canvas.bind(self.k_enter2, self.statechange) #*01
        self.canvas.bind(self.k_oup2, self.pageup)
        self.canvas.bind(self.k_odown2, self.pagedown)
        self.canvas.bind(self.k_rot2, self.rot_port)
        self.canvas.bind(self.k_lntop2, self.linetop)
        self.canvas.bind(self.k_sleft2, self.scrolleft)
        self.canvas.bind(self.k_sright2, self.scrolright)
        self.canvas.bind(self.k_softkeybar2, self.softkeybar_onoff) #*01E7
        if self.status==2 and self.word_wrap:
            self.state2()
        else:
            if self.curLNo>self.staSLNo+self.GYOU-2:
                self.curLNo=self.staSLNo+self.GYOU-2
            self.script_lock.signal()


    def rot_port(self):
        if self.Edit_flag and self.word_wrap:
            rtn = appuifw.query(unicode("When exec rotate\nedit is discarded\ndata already saved ?"), "query")
            if not rtn:
                return
        appuifw.app.orientation='portrait'
#        appuifw.app.screen = "full"
        self.MOJI=self.MOJI1
        self.GYOU=self.GYOU1
        self.HABA=self.HABA1
        
        self.canvas.bind(self.k_lntop2, self.do_dummy) #* change to unuse, -
        #* - use do_dummy, never use 'None'(if use, error occured in first time)
        self.canvas.bind(self.k_left1, self.moveleft)
        self.canvas.bind(self.k_right1, self.moveright)
        self.canvas.bind(self.k_up1, self.lineup)
        self.canvas.bind(self.k_down1, self.linedown)
        self.canvas.bind(self.k_state1, self.statechange)
        self.canvas.bind(self.k_enter1, self.statechange) #*01
        self.canvas.bind(self.k_oup1, self.pageup)
        self.canvas.bind(self.k_odown1, self.pagedown)
        self.canvas.bind(self.k_rot1, self.rot_land)
        self.canvas.bind(self.k_lntop1, self.linetop)
        self.canvas.bind(self.k_sleft1, self.scrolleft)
        self.canvas.bind(self.k_sright1, self.scrolright)
        self.canvas.bind(self.k_softkeybar1, self.softkeybar_onoff) #*01E7
        if self.status==2 and self.word_wrap:
            self.state2()
        else:
#            if self.curLNo>self.staSLNo+self.GYOU-2:
#                self.curLNo=self.staSLNo+self.GYOU-2
            self.script_lock.signal()


    def rot_clear(self):
        appuifw.app.orientation='automatic'
        appuifw.app.screen = "normal"


    def rot_normal(self):
        appuifw.app.screen = "normal"


    def rot_full(self):
        appuifw.app.screen = "full"


    def rot_large(self): #*01E7
        appuifw.app.screen = "large"


    def rot_fix(self):  #*01E7 画面向きを検出してキーを正しく再設定する
        width,hight = self.canvas.size
        if hight > width:
            self.rot_port()
        else:
            self.rot_land()


    def softkeybar_onoff(self): #*01E7
        if appuifw.app.screen == "full":
            self.rot_large()
        else:
            self.rot_full()


    def wrap_onoff(self):
        if self.word_wrap: self.word_wrap=0
        else:              self.word_wrap=1
        self.menu_option = (unicode("Option"),
                           ((unicode("word wrap %s" %("On","Off")[self.word_wrap]), self.wrap_onoff),
                            (unicode("Line number"), self.line_num_state)))
        self.set_app_menu_edit()
        self.dspSTpos=0
        if self.file_path:
            self.state2()


    def line_num_state(self):
        old_line_number=self.line_number
        m = [unicode(' No line number'), unicode(' All line'), unicode(' Physical line')]
        if self.line_number < 3:
            m[self.line_number] = '*'+m[self.line_number][1:]
        tmpN=appuifw.popup_menu(m)
        if tmpN != None:
            if   tmpN == 0: self.line_number=0
            elif tmpN == 1: self.line_number=1
            else          : self.line_number=2
            
            if (old_line_number==0 and self.line_number) or \
               (old_line_number and self.line_number==0):
                self.state2()
            else:
                self.set_app_menu_edit()
                self.script_lock.signal()


    def set_app_menu_edit(self):
        if self.line_number>0 and self.word_wrap==0: #line_number=1 or 2
            appuifw.app.menu = [self.menu_edit, self.menu_find, self.menu_jump, self.menu_option, self.menu_exit]
        else:
            appuifw.app.menu = [self.menu_find, self.menu_jump, self.menu_option, self.menu_exit]


    def set_app_menu_save(self):
        if self.Edit_flag:
            appuifw.app.menu = [self.menu_save, self.menu_edit, self.menu_find, self.menu_jump, self.menu_exit]
        else:
            appuifw.app.menu = [self.menu_edit, self.menu_find, self.menu_jump, self.menu_option, self.menu_exit]


    def confread(self):
        try:
            f=open('e:\\Data\\masa\\PyDocViewer.conf','r')
            fData=f.read()
            f.close()
        except:
            return
        
        lnData=fData.split("\n")
        
        for tmpA in range(len(lnData)):
            confData=lnData[tmpA].split("=")
            if confData[0]=="TEMP":
                self.pathtmp=confData[1]
            elif confData[0]=="FONT_TPL":
                font_wk=confData[1].split(",")
                self.FONT=(unicode(font_wk[0]),int(font_wk[1]),int(font_wk[2]))
            elif confData[0]=="MOJI1":
                self.MOJI1=int(confData[1])
            elif confData[0]=="GYOU1":
                self.GYOU1=int(confData[1])
            elif confData[0]=="HABA1":
                self.HABA1=int(confData[1])
            elif confData[0]=="MOJI2":
                self.MOJI2=int(confData[1])
            elif confData[0]=="GYOU2":
                self.GYOU2=int(confData[1])
            elif confData[0]=="HABA2":
                self.HABA2=int(confData[1])
            elif confData[0]=="LEFT1":
                self.k_left1=int(confData[1],16)
            elif confData[0]=="RIGHT1":
                self.k_right1=int(confData[1],16)
            elif confData[0]=="UP1":
                self.k_up1=int(confData[1],16)
            elif confData[0]=="DOWN1":
                self.k_down1=int(confData[1],16)
            elif confData[0]=="SELECT1":
                self.k_state1=int(confData[1],16)
            elif confData[0]=="ENTER1":            #*01
                self.k_enter1=int(confData[1],16)
            elif confData[0]=="ONEUP1":
                self.k_oup1=int(confData[1],16)
            elif confData[0]=="ONEDOWN1":
                self.k_odown1=int(confData[1],16)
            elif confData[0]=="ROTATE1":
                self.k_rot1=int(confData[1],16)
            elif confData[0]=="LNTOP1":
                self.k_lntop1=int(confData[1],16)
            elif confData[0]=="SLEFT1":
                self.k_sleft1=int(confData[1],16)
            elif confData[0]=="SRIGHT1":
                self.k_sright1=int(confData[1],16)
            elif confData[0]=="SOFTKEYBAR1":
                self.k_softkeybar1=int(confData[1],16) #*01E7
            elif confData[0]=="LEFT2":
                self.k_left2=int(confData[1],16)
            elif confData[0]=="RIGHT2":
                self.k_right2=int(confData[1],16)
            elif confData[0]=="UP2":
                self.k_up2=int(confData[1],16)
            elif confData[0]=="DOWN2":
                self.k_down2=int(confData[1],16)
            elif confData[0]=="SELECT2":
                self.k_state2=int(confData[1],16)
            elif confData[0]=="ENTER2":            #*01
                self.k_enter2=int(confData[1],16)
            elif confData[0]=="ONEUP2":
                self.k_oup2=int(confData[1],16)
            elif confData[0]=="ONEDOWN2":
                self.k_odown2=int(confData[1],16)
            elif confData[0]=="ROTATE2":
                self.k_rot2=int(confData[1],16)
            elif confData[0]=="LNTOP2":
                self.k_lntop2=int(confData[1],16)
            elif confData[0]=="SLEFT2":
                self.k_sleft2=int(confData[1],16)
            elif confData[0]=="SRIGHT2":
                self.k_sright2=int(confData[1],16)
            elif confData[0]=="SOFTKEYBAR2":
                self.k_softkeybar2=int(confData[1],16) #*01E7
            elif confData[0]=="WORD_WRAP":
                self.word_wrap=int(confData[1])
            elif confData[0]=="LINE_NUMBER":
                self.line_number=int(confData[1])
            elif confData[0]=="EFSIZE":
                self.edit_fontsize=int(confData[1]) 


    def jumpnum(self):
        jnum = appuifw.query(unicode("Jump to:"), "number", 1)
        if jnum==None:
            self.script_lock.signal()
            return
        if self.status==2:
            if self.line_number==2: #physical
                if jnum<=1:
                    self.curLNo=0
                else:
                    for tmpN in range(self.lastNo):
                        if self.scrData[tmpN][1]==jnum:
                            self.curLNo=tmpN
                            break
                    else:
                        self.curLNo=self.lastNo-1
            else:
                if jnum<=1:
                    self.curLNo=0
                elif jnum>self.lastNo:
                    self.curLNo=self.lastNo-1
                else:
                    self.curLNo=jnum-1

            if self.curLNo>=self.staSLNo and self.botSLNo>=self.curLNo:
                pass
            else:
                self.staSLNo=self.curLNo
#            self.dspSTpos=0 #go to top of line
            self.rot_full() #*01E7
            self.script_lock.signal()


    def findtext(self, text=""):
        if self.status==2:
            if text == "": 
                ftext = appuifw.query(unicode("Serch for:"), "text", self.last_find)
            else:
                ftext = text #self.last_find
            if ftext==None: #canceled
#                self.script_lock.signal()
                return
            self.last_find = ftext

            tmpA=self.staSLNo+1
            if tmpA>self.lastNo-1:
                tmpA=0
            
            while tmpA < self.lastNo:
                stext=(self.scrData[tmpA][0]).lower()
                if stext.find(unicode(ftext).lower())>=0:
                    self.staSLNo=tmpA
                    self.curLNo=self.staSLNo
#                    self.dspSTpos=0 #go to top of line
                    self.script_lock.signal()
                    break
                
                tmpA=tmpA+1
                if tmpA == self.lastNo:
                    tmpA=0
                
                if tmpA == self.staSLNo+1:
                    appuifw.note(unicode("Not found"), "info")
                    self.script_lock.signal()
                    break


    def find_all(self, text=""):
        if self.status==2:
            if text == "": 
                ftext = appuifw.query(unicode("Serch for:"), "text", self.last_find)
            else:
                ftext = text #self.last_find
            if ftext==None: #canceled
#                self.script_lock.signal()
                return
            self.last_find = ftext

            result_list=[]
            LNo_list=[]
            for tmpA in range(self.lastNo):
                stext=(self.scrData[tmpA][0])
                find_list = (re.compile(unicode(ftext), re.I)).finditer(stext)
                for m_start in find_list: #call iter. and get result one by one
                    pos_st = m_start.start()             #position
                    pos_wk=pos_st-2
                    if pos_wk<0: pos_wk=0
                    tmpW=self.check_width(stext[:pos_st])
                    result_list.append(u'%d:%d:%s' % (tmpA+1, tmpW, stext[pos_wk:pos_wk+10]))
                    LNo_list.append([tmpA, tmpW])

            if LNo_list==[]:
                appuifw.note(unicode("Not found"), "info")
            else:
                tmpN=appuifw.popup_menu(result_list, u'Slelct to go (Find all)')
                if tmpN!=None:
                    self.staSLNo=LNo_list[tmpN][0]
                    self.curLNo=self.staSLNo
                    if self.word_wrap==0:
                        self.dspSTpos=LNo_list[tmpN][1]-3
                        if self.dspSTpos<0:
                            self.dspSTpos=0
            self.script_lock.signal()


    def find_ed(self, text=""):
        curr_pos = self.textbody.get_pos()
        t = self.textbody.get()

        if text == "": 
            f = appuifw.query(u"Find text:",'text', self.last_find)
            pos_offset = 0
        else:
            f = text #self.last_find
            pos_offset = 1 #searc start point offset
        if not f:
            return #cancel
        self.last_find = f

        pattern = re.compile(f, re.I)
        m_start = pattern.search(t, curr_pos + pos_offset)

        if m_start == None:
            if appuifw.query(u"Not found. Go to Top?",'query'):
                self.textbody.set_pos(0)
        else:
            self.textbody.set_pos(m_start.start())


    def find_all_ed(self, text=""):
        curr_pos = self.textbody.get_pos()
        t = self.textbody.get()

        if text == "": 
            f = appuifw.query(u"Find text:",'text', self.last_find)
        else:
            f = text #self.last_find
        if not f: return #cancel
        self.last_find = f

        pattern = re.compile(f, re.I)
        start_list = []
        result_list = []
        find_list = pattern.finditer(t, 0)  #find all

        for x in find_list: #call iter. and get result one by one
            r_p = x.start()                       #position
            start_list.append(r_p)
            if r_p < 3:
                r_t = t[0:12]     #text partial
            else:
                r_t = t[r_p-2:r_p+12]     #text partial
            result_list.append(str(r_p)+u": "+r_t)  #menu list

        if result_list == []: #don't use start_list for check
            appuifw.query(u"Not found.",'query')
        else:
            r_n = appuifw.popup_menu(result_list, u'Slelct to go (Find all)')
            if r_n != None:
                self.textbody.set_pos(start_list[r_n])


    def backstate(self):
        if  self.status==2:
            if self.Edit_flag:
                rtn = appuifw.query(unicode("Really exit?\nedit is discarded\ndata already saved ?"), "query")
                if not rtn:
                    return
            self.Edit_flag=0
            self.state1()
            self.script_lock.signal()
        elif self.status==1:
            self.exit_key_handler()
            self.script_lock.signal()


    def state1(self):
        self.status=1
        self.canvas.clear()
        self.rot_normal()
#        self.rot_port()
        self.rot_clear() #*01E7
        appuifw.app.menu = [self.menu_file, self.menu_info, self.menu_exit]


    def state2(self):
        self.status=2
        self.set_app_menu_edit()
        self.canvas.clear()
        self.rot_fix()  #*01E7
        self.rot_full()
        self.fileread()
        self.Edit_flag=0
        # #*01 need for 5800XM, because "redraw_callback" doesn't work in 5800XM
#        self.draw_state() #*01
        self.script_lock.signal()


    def statechange(self):
        if self.status==2:
            if self.line_number>0 and self.word_wrap==0:
                m = [u'Edit line', u'Insert line',u'Delete line']
                i=appuifw.popup_menu(m)
                if i != None:
                    if   i == 0: self.edit_line()
                    elif i == 1: self.insert_line()
                    elif i == 2: self.delete_line()


    def edit_line(self):
        if self.status==2:
            tmpDT = self.scrData[self.curLNo][0]
#            self.oldbody=appuifw.app.body
            self.textbody = appuifw.Text()
            appuifw.app.body = self.textbody
            self.textbody.font = (self.FONT[0], self.edit_fontsize, self.FONT[2])
            self.textbody.color = 0x000000
            appuifw.app.menu = [self.menu_edit_ed, self.menu_goto_ed, self.menu_find_ed]
            self.textbody.set(tmpDT)
            self.textbody.set_pos(0)
            self.status=3
            self.rot_large() #*01E7
            appuifw.app.exit_key_handler = self.edit_can


    def insert_line(self):
        if self.status==2:
            tmpN=self.curLNo+1
            rtn = appuifw.query(unicode("Done insert %s ?" % tmpN), "query")
            if not rtn:
                return
            self.scrData.insert(self.curLNo, ['', tmpN, tmpN])
            for tmpA in range(self.curLNo+1 ,len(self.scrData)):
                self.scrData[tmpA][1],self.scrData[tmpA][2]=tmpA+1,tmpA+1
            self.lastNo=len(self.scrData)-1
            self.Edit_flag=1

            self.set_app_menu_save()
            self.script_lock.signal()


    def delete_line(self):
        if self.status==2:
            tmpN=self.curLNo+1
            rtn = appuifw.query(unicode("Done delete %s ?" % tmpN), "query")
            if not rtn:
                return
            rtn=self.scrData.pop(self.curLNo) #delete line
            for tmpA in range(self.curLNo ,len(self.scrData)):
                self.scrData[tmpA][1],self.scrData[tmpA][2]=tmpA+1,tmpA+1
            self.lastNo=len(self.scrData)-1
            if self.curLNo>self.lastNo-1:
                self.curLNo=self.lastNo-1
            self.Edit_flag=1

            self.set_app_menu_save()
            self.script_lock.signal()


    def edit_done(self):
        if self.status==3:
            rtn = appuifw.query(unicode("Done edit ?"), "query")
            if rtn:
                tmpDT=self.textbody.get()
                tmpDT = tmpDT.replace(u"\u2029", u"")
                self.scrData[self.curLNo][0]=tmpDT
                self.Edit_flag=1

                self.status=2
                self.rot_full() #*01E7
                appuifw.app.body = self.canvas #self.oldbody
                self.set_app_menu_save()
                self.script_lock.signal()


    def edit_can(self):
        if self.status==3:
            rtn = appuifw.query(unicode("Cancel edit ?"), "query")
            if rtn:
                self.status=2
                self.rot_full() #*01E7
                appuifw.app.body = self.canvas #self.oldbody
                self.set_app_menu_save()
                self.script_lock.signal()


    def save(self, path=None):
        if path:
            save_dest=path
        else:
            save_dest=self.file_path
        tmpDA=""
        tmpDT=""
        for tmpN in range(self.lastNo):
            if self.Encoding.upper()=="UTF-8": # UTF-8
                tmpDA=self.scrData[tmpN][0]
                tmpDA=tmpDA.replace(u"\uFF5E", u"\u301C") #wave line
                tmpDA=tmpDA.encode('UTF-8')
                if self.scrData[tmpN][1]: #top of line
                    if tmpDT:
                        tmpDT=tmpDT+"\n"+tmpDA
                    else:
                        tmpDT=tmpDA
                else:
                    tmpDT=tmpDT+tmpDA
            else: # Shift-JIS
                tmpDA=self.scrData[tmpN][0]
                tmpDA=tmpDA.replace(u"\uFF5E", u"\u301C") #wave line
                tmpDA=tmpDA.replace(u"\uFF0D", u"\u30FC") #hyphen
                tmpDA=tmpDA.encode('Shift-JIS')
                if self.scrData[tmpN][1]: #top of line
                    if tmpDT:
                        tmpDT=tmpDT+"\r\n"+tmpDA
                    else:
                        tmpDT=tmpDA
                else:
                    tmpDT=tmpDT+tmpDA
        try:
            f=open(save_dest,'wb')
            f.write(tmpDT)
            f.close()
        except:
            subque = appuifw.query(unicode("Write error occured"), "query")
            return
        self.Edit_flag=0
        self.file_path=save_dest
        appuifw.app.body = self.canvas #self.oldbody
        self.set_app_menu_save()
#        self.state2
        self.script_lock.signal()


    def save_as(self):
        tmpP = os.path.split(self.file_path)
        save_dest = self.Gpath.get_write_path(title='File name', \
                     default_path=tmpP[0], msg_ex=tmpP[1])
        if save_dest:
            self.save(save_dest)


    def go_top(self):
        self.textbody.set_pos(0)


    def go_end(self):
        text = self.textbody.get()
        self.textbody.set_pos(len(text))


    def pageup(self):
        if self.status==2:
            self.staSLNo=self.staSLNo-(self.GYOU-2)
            if self.staSLNo<0:
                self.staSLNo=0
            self.curLNo=self.curLNo-(self.GYOU-2)
            if self.curLNo<0:
                self.curLNo=0
            self.rot_full() #*01E7
            self.script_lock.signal()


    def pagedown(self):
        if self.status==2:
            if self.staSLNo < self.lastNo:
                if self.botSLNo < self.lastNo-1:
                    self.staSLNo=self.botSLNo
                else:
                    self.staSLNo=self.botSLNo-1
                self.curLNo=self.curLNo+(self.GYOU-2)
                if self.curLNo>self.lastNo-1:
                    self.curLNo=self.lastNo-1
                self.rot_full() #*01E7
                self.script_lock.signal()


    def lineup(self):
        if self.status==2:
            if self.curLNo>0:
                self.curLNo=self.curLNo-1
                if self.curLNo<self.staSLNo:
                    self.staSLNo=self.staSLNo-1
                self.rot_full() #*01E7
                self.script_lock.signal()


    def linedown(self):
        if self.status==2:
            if self.curLNo<self.lastNo-1:
                self.curLNo=self.curLNo+1
                if self.curLNo>self.botSLNo:
                    self.staSLNo=self.staSLNo+1
                self.rot_full() #*01E7
                self.script_lock.signal()


    def moveleft(self):
        if self.status==2:
            if self.word_wrap==0:
                if self.line_number==0:
                    self.dspSTpos=self.dspSTpos - self.MOJI
                else:
                    self.dspSTpos=self.dspSTpos - (self.MOJI-5)
                if self.dspSTpos < 0:
                    self.dspSTpos=0
                self.script_lock.signal()


    def moveright(self):
        if self.status==2:
            if self.word_wrap==0:
                if self.line_number==0:
                    self.dspSTpos=self.dspSTpos + self.MOJI
                else:
                    self.dspSTpos=self.dspSTpos + (self.MOJI-5)
                self.script_lock.signal()


    def scrolleft(self):
        if self.status==2:
            if self.word_wrap==0:
                self.dspSTpos=self.dspSTpos-2
                if self.dspSTpos < 0:
                    self.dspSTpos=0
                self.script_lock.signal()


    def scrolright(self):
        if self.status==2:
            if self.word_wrap==0:
                self.dspSTpos=self.dspSTpos+2
                self.script_lock.signal()


    def linetop(self):
        if self.status==2:
            if self.word_wrap==0:
                self.dspSTpos=0
                self.script_lock.signal()


    def do_exit(self):
        if self.Edit_flag:
            rtn = appuifw.query(unicode("Really exit?\nedit is discarded\ndata already saved ?"), "query")
            if not rtn:
                return
        self.Edit_flag=0
        self.exit_key_handler()


    def exit_key_handler(self):
        appuifw.app.exit_key_handler = None
        self.viewing=0
        self.script_lock.signal()


    def do_dummy(self):
        pass


    def fileread(self):
        try:
            f=open(self.file_path,'r')
            fData_wk=f.read()
            f.close()
            self.staSLNo=0 #* drow from first article
            self.curLNo=self.staSLNo
        except:
            subque = appuifw.query(unicode("File not Exist"), "query")
            return

        Enc, fData = self.check_encode(fData_wk) #check and decode
        self.Encoding=Enc

        fData=fData.replace(u"\r\n", u"\n")
        lnData=fData.split(u"\n")

        self.scrData = []

        if self.word_wrap:
            #word wrap process 
            tmpB=1
            if self.line_number==0: #no number
                tmpMOJI=self.MOJI
            else:
                tmpMOJI=self.MOJI-5
            for tmpC in range(len(lnData)):
                tmpDC=lnData[tmpC]
                tmpST=0
                tmpDT=""
                tmpW=0
                tmpD=0
                for tmpD in range(len(tmpDC)):
                    tmpDL=repr(tmpDC[tmpD])
                    if len(tmpDL)<6 or (tmpDL[4:8]>='ff61' and tmpDL[4:8]<='ff9f'):
                        tmpW=tmpW+1
                    else:
                        tmpW=tmpW+2
                    if tmpW>=tmpMOJI:
                        tmpDT=tmpDC[tmpST:tmpD+1]
                        if tmpST==0:
                            self.scrData.append([tmpDT, tmpC+1, tmpB])
                        else:
                            self.scrData.append([tmpDT, '', tmpB])
                        tmpST=tmpD+1
                        tmpW=0
                        tmpB=tmpB+1
                else:
                    if tmpST==0: #1st time
                        tmpDT=tmpDC[tmpST:]
                        self.scrData.append([tmpDT, tmpC+1, tmpB])
                        tmpB=tmpB+1
                    else:
                        if tmpW>0:
                            tmpDT=tmpDC[tmpST:]
                            self.scrData.append([tmpDT, '', tmpB])
                            tmpB=tmpB+1
            self.scrData.append([u'[EOF]', tmpC+2, tmpB])
        else:
            for tmpC in range(len(lnData)):
                self.scrData.append([lnData[tmpC], tmpC+1, tmpC+1])
            self.scrData.append([u'[EOF]', tmpC+2, tmpC+2])

        self.lastNo=len(self.scrData)-1
        self.status=2
        self.botSLNo=0
        
        return


    def draw_state(self):
        self.canvas.clear()
        
        #Slead View
        if self.status==2:
            dsA=self.staSLNo
            dsY=0

            gauge_icon=(u'---------', u'-=-=-=-=-', u'=========')

            tmpB = u''
            for tmpM in range(2):
                tmpA=(int(self.dspSTpos/100)+tmpM) % 3 #0-2
                for tmpN in range(10):
                    tmpB = tmpB + u"%d%s" % (tmpN, gauge_icon[tmpA])

            if self.line_number==0: #no number
                tmpMOJI=self.MOJI
            else:
                tmpMOJI=self.MOJI-5

            tmpA=self.dspSTpos % 100
            if self.word_wrap:
                tmpC =  (tmpB[tmpA:])[:tmpMOJI]
            else:
                tmpC =  (tmpB[tmpA:]) [:100]

            fmtA, fmtB, fmts  = u'%4d|%s', u'  --|%s', u'----|%s'

            while dsY < self.GYOU:
                if dsY == 0:
                    if self.line_number==0: #none
                        tmpD = tmpC
                    else:
                        tmpD = fmts % (tmpC)
                    self.canvas.text( (3,dsY*self.HABA+self.HABA+1), tmpD, 0x000000, self.FONT)
                    dsY=dsY+1

                tmpD = self.scrData[dsA][0]
                tmpST = self.get_start_pos(tmpD)

                if   self.line_number==0: #none
                    if dsA < self.lastNo:
                        tmpD =(tmpD[tmpST:])[:self.MOJI]
                    else:
                        pass # "[EOF]" in tmpD

                elif self.line_number==1: #word pro. like
                    if dsA < self.lastNo:
                        tmpD = fmtA % (self.scrData[dsA][2] % 10000, (tmpD[tmpST:])[:self.MOJI])
                    else:
                        tmpD = fmtA % (self.scrData[dsA][2] % 10000, tmpD) #[EOF]

                else : #editor like
                    if self.scrData[dsA][1]: #physical line num exist
                        if dsA < self.lastNo:
                            tmpD = fmtA % (self.scrData[dsA][1] % 10000, (tmpD[tmpST:])[:self.MOJI])
                        else:
                            tmpD = fmtA % (self.scrData[dsA][1] % 10000, tmpD) #[EOF]
                    else: #physical line num not exist
                        tmpD = fmtB % (tmpD[tmpST:])[:self.MOJI]

                if dsA==self.curLNo:
                    self.canvas.rectangle((0, dsY*self.HABA+1, 650,dsY*self.HABA+self.HABA+3),fill=0xAAFF99)
                    self.canvas.text( (3,dsY*self.HABA+self.HABA+1), tmpD, 0xCC0000, self.FONT)
                else:
                    self.canvas.text( (3,dsY*self.HABA+self.HABA+1), tmpD, 0x000000, self.FONT)
                dsY=dsY+1
                if dsY > (self.GYOU-1):
                    break

                dsA=dsA+1
                if dsA>self.lastNo:
                    dsA=dsA-1
                    break
                
            self.botSLNo=dsA

        #Board Title
        elif self.status==1:
            tmpStr = unicode('please start from menu','UTF-8')
            tmpFont=(self.FONT[0], self.FONT[1]+4, self.FONT[2])
            self.canvas.text( (30,self.HABA*3), tmpStr, 0x000000, tmpFont)


    def get_start_pos(self, data):
        if self.dspSTpos==0 or self.word_wrap==1:
            pos=0
        elif len(data)*2<=self.dspSTpos:
            pos=len(data)
        else:
            tmpW=0
            for tmpD in range(len(data)):
                tmpDD=repr(data[tmpD])
                if len(tmpDD)<6 or (tmpDD[4:8]>='ff61' and tmpDD[4:8]<='ff9f'):
                    tmpW=tmpW+1
                else:
                    tmpW=tmpW+2
                if tmpW>=self.dspSTpos:
                    pos=tmpD+1
                    break
            else:
                pos=len(data)
        return pos


    def check_width(self, data):
        tmpW=0
        for tmpDT in data:
            tmpDD=repr(tmpDT)
            if len(tmpDD)<6 or (tmpDD[4:8]>='ff61' and tmpDD[4:8]<='ff9f'):
                tmpW=tmpW+1
            else:
                tmpW=tmpW+2
        return tmpW



    def open_file(self, dir_path=None):
        if   dir_path       : temp_dir = dir_path
        elif self.file_path : temp_dir = os.path.split(self.file_path)[0]
        elif self.pathtmp   : temp_dir = self.pathtmp
        else                : temp_dir = None

        open_path = self.Gpath.get_read_path(default_path = temp_dir)
        appuifw.app.body=self.canvas
        if open_path:
            self.file_path = open_path
            self.state2()
        else:
            self.state1()
            self.script_lock.signal()


    def check_encode(self, text_data, encoding=None):
        if encoding : enc_list = [encoding]
        else        : enc_list = ["UTF-8", "Shift-JIS"]

        for enc in enc_list:
            try:
                new_data = text_data.decode(enc)
                Enc = enc
                break
            except:
                pass
        else:
            if encoding : Enc = encoding
            else        : Enc = "UTF-8"
            try:
                new_data = text_data.decode(Enc, "replace")
            except: # may be never come here
                Enc = "UTF-8"
                new_data = u'text decode error occured'
        return Enc, new_data


    def about(self):
        msg =     (__script__) \
         + '\n' + ('Ver_' + __ver__) \
         + '\n' + (__Copyright__) \
         + '\n' + (__web__ )
        appuifw.query(unicode(msg, "utf-8"), "query")


    def run(self):
        self.confread()
        appuifw.app.exit_key_handler = None
        appuifw.app.screen='normal'
        self.canvas=appuifw.Canvas(redraw_callback=lambda rect:self.draw_state())
        appuifw.app.body=self.canvas
        appuifw.app.menu=[self.menu_file, self.menu_info, self.menu_exit]
        oldtitle=appuifw.app.title
        appuifw.app.title=unicode(__script__)
#        self.rot_port()
        self.rot_clear() #*01E7
        self.state1()

        while self.viewing:
            appuifw.app.exit_key_handler = self.backstate
            self.draw_state()
            self.script_lock.wait()
        appuifw.app.title=oldtitle
        self.rot_clear()


if __name__ == '__main__':
    window=viewer()
    window.run()

#    sys.exit()

